//
// Created by spenc on 5/14/2025.
//

#ifndef CORE_H
#define CORE_H

#include <utility>
#include <vector>
#include <memory>
#include "Layer.h"
#include "systems/Logger.h"
#include "systems/Profiler.h"
#include "systems/WindowManager.h"

namespace OX
{
    class Core {
    public:
        Core(std::string name) : m_name(std::move(name)) {};
        ~Core() = default;

        void Init();
        void Run();
        void Shutdown();


        WindowManager& GetWindow() {return window;}




        void AddLayer(std::unique_ptr<Layer> layer);

    private:
        void Update();
        void Draw();


        std::vector<std::unique_ptr<Layer>> m_layers;
        WindowManager window;

        bool m_running = false;
        std::string m_name = "Application";
    };
}
#endif // CORE_H

